PrintWriter writer;   // ファイルを書き出すための変数を定義

void setup()
{
    size(640, 480);   // 640×480ドットの画面を作成
    background(192);  // 背景を明るい灰色
    fill(255);        // 塗りつぶしの色を白
    stroke(0);        // 線の色を黒
    rectMode(CENTER); // 四角を書くときの基準位置を中心に
}

void draw()
{
    if (mousePressed == true) {               // マウスが押されているならば
        if (mouseButton == LEFT) {            // マウスの左ボタンが押されていれば
            background(192);                  // 明るい灰色で塗りつぶして画面を更新
            ellipse(mouseX, mouseY, 20, 20);  // マウスの位置に円を表示
            writer.println(mouseX + "," + mouseY);  // ファイルにマウスの位置をカンマ区切りで書き出す
        }
    }
}

void mousePressed()
{
    if (mouseButton == LEFT) {
        writer = createWriter("data.txt");  // マウス位置を保存するためのファイルを設定
    } else if (mouseButton == RIGHT) {      // マウスの右ボタンが押されていれば
        background(192);                    // 明るい灰色で塗りつぶして画面を更新
        BufferedReader reader;              // ファイルを読み出すための変数を定義
        String line;                        // ファイルから読み込んだ文字を保存する変数を定義
        reader = createReader("data.txt");  // 読み込みファイルを設定
        boolean z = true;                   // ファイルからデータを読み込めなかったときにfalseにする
        while (z) {                         // ファイルからデータが読み込めていればループ
            try {
                line = reader.readLine();   // ファイルから文字列として1行読み込む
            }
            catch (IOException e) {         // 読み込めなかったら
                line = null;                // nullという値にする
            }
            if (line == null) {             // もし，読み込めなかったら（ファイルの終わりまで読み込んでいたら）
                z = false;                  // ファイル読み込みを終了するためにfalseにする
            } else {
                int pos[] = int(split(line, ','));  // 読み込んだ文字列をカンマで分割してposという配列へ
                rect(pos[0], pos[1], 20, 20);  // 保存したマウス位置を読み出し，四角を描く
            }
        }
    }
}

void mouseReleased()
{
    if (mouseButton == LEFT) {
          writer.flush();            // バッファに残っているデータをファイルに書き込む
          writer.close();            // ファイルを閉じる
    }
}

