import processing.serial.*;    // Arduinoと通信するためのライブラリを読み込む

Serial port;                   // シリアル通信を行うための変数の定義
int rv, gv, bv;                // クリックした位置を保存しておく変数の定義

void setup()
{
    size(255, 255);                         // 255x255ドットの画面を作成
    port = new Serial(this, "COM3", 9600);  // 通信ポートと速度の設定
}

void draw()
{
    for (int i=0; i<255; i++) {             // 赤，緑，青のグラデーションを作成
        stroke(i, 0, 0);                    // 赤
        line(i, 0, i, 63);
        stroke(0, i, 0);                    // 緑
        line(i, 64, i, 127);
        stroke(0, 0, i);                    // 青
        line(i, 128, i, 191);
    }
    stroke(255, 255, 255);                  // 線の色を白
    noFill();                               // 塗りつぶしをなし
    ellipse(rv, 28, 10, 10);                // クリックした位置に円を描く
    ellipse(gv, 28 + 64, 10, 10);
    ellipse(bv, 28 + 128, 10, 10);

    stroke(rv, gv, bv);                     // 線の色をクリックした位置の3つの色に
    fill(rv, gv, bv);                       // 塗りつぶし色を変える
    rect(0, 192, 200, 64);                  // 左下の色を変える

    fill(255);                              // 白で塗りつぶすことで
    rect(200, 192, 55, 64);                 // 右下の文字を更新
    fill(0);                                // 文字の色を黒に
    text("R" + rv, 210, 210);               // マウスの位置を右下に数字で表示
    text("G" + gv, 210, 230);
    text("B" + bv, 210, 250);
}

void mousePressed()
{
    if (mouseY < 64) {          // クリックした位置が赤のグラデーション範囲なら
        rv = mouseX;            // マウスの位置を保存
    } else if (mouseY < 128) {  // クリックした位置が緑のグラデーション範囲なら
        gv = mouseX;
    } else if (mouseY < 192) {  // クリックした位置が青のグラデーション範囲なら
        bv = mouseX;
    }
    port.write("a" + str(rv) + "," + str(gv) + "," + str(bv) + "\n");  // カンマ区切りテキストとして送信
}

