import processing.serial.*;    // Arduinoと通信するためのライブラリを読み込む

Serial port;                   // シリアル通信を行うための変数の定義

void setup()
{
    size(255, 255);                         // 255×255ドットの画面を作成
    port = new Serial(this, "COM3", 9600);  // 通信ポートと速度の設定
    frameRate(30);                          // フレームレートを30fps
    stroke(0);                              // 線の色を黒
    fill(255);                              // 塗りつぶし色を白
    rectMode(CENTER);                       // 四角を書くときの基準位置を中心
}

void draw()
{
    background(192);                        // 背景を明るい灰色で塗りつぶして更新
    if (mousePressed == true) {             // マウスが押されていれば
        port.write('a');                    // 「a」を送信
        ellipse(127, 127, 100, 100);        // 円を表示
    } else {                                // 押されていなければ
        port.write('b');                    // 「b」を送信
        rect(127, 127, 100, 100);           // 四角を表示
    }
}

