import processing.serial.*;    // Arduinoと通信するためのライブラリを読み込む

Serial port;                   // シリアル通信を行うための変数の定義
int mx, my;                    // クリックしたときのマウスの位置を保存する変数の定義

void setup()
{
    size(255, 150);                         // 255×150ドットの画面を作成
    port = new Serial(this, "COM3", 9600);  // 通信ポートと速度の設定
    port.write(0);                          // 0を送ることでArduinoに付いているLEDの明るさを最低（消えた状態）に
    mx = my = 0;                            // クリックしたときのマウスの位置の初期値を0に
}

void draw()
{
    int i;
    for (i=0; i<255; i++) {                 // グラデーションの表示
        stroke(i);                          // 線の色を0から1ずつ増やして255までの変えながら
        line(i, 0, i, 100);                 // 太さ1の線を255本書くことでグラデーションを描く
    }
    fill(mx);                               // 塗りつぶしの色を変える
    rect(0, 100, 200, 50);                  // 左下の色を変える
    fill(255);                              // 白で塗りつぶすことで
    rect(200, 100, 55, 50);                 // 右下の文字を更新
    fill(0);                                // 文字の色を黒に
    text(mx, 210, 130);                     // マウスの位置を右下に数字で表示
    ellipse(mx, my, 10, 10);                // クリックした位置に円を描く
}

void mousePressed()
{
    port.write(mouseX);      // クリックした位置を送信し，Arduinoに付いているLEDの明るさを変える
    mx = mouseX;             // クリックした位置を保存
    my = mouseY;
}

