import processing.serial.*;   // Arduinoと通信するためのライブラリを読み込む

Serial port;                  // シリアル通信を行うための変数の定義

void setup()
{
    size(511, 100);                          // 511×100ドットの画面を作成
    port = new Serial(this, "COM3", 9600);   // 通信ポートと速度の設定
    fill(0);                                 // 文字の色を黒
    rectMode(CENTER);                        // 四角を書くときの基準位置を中心
    frameRate(30);                           // フレームレートを30fps
}

void draw()
{
    int v;
    background(255);                         // 画面を白で塗りつぶして更新
    line(width/2, 0, width/2, height);       // 画面の中央に線を引く
    v = mouseX;                              // マウスの位置をvに代入しておく
    if (mousePressed == false) {             // マウスが押されていなければ
        ellipse(mouseX, mouseY, 10, 10);     // マウスの位置に黒い円を描く
        if (v < 256) {                       // その位置が左の方にあれば
            v = 255-v;                       // 0 ～ 255の値を255 ～ 0に変える
            port.write('f');                 // 正転の指令を送信する
            port.write(v);                   // モーターの速さを送信する
            text("正転" + v, 10, 35);        // 左上にその値を表示する
        } else {                             // その位置が右の方にあれば
            v = v-256;                       // 256 ～ 511の値を0 ～ 255に変える
            port.write('r');                 // 逆転の指令を送信する
            port.write(v);                   // モーターの速さを送信する
            text("逆転" + v, 10, 35);        // 左上にその値を表示する
        }
    } else {                                 // マウスが押されていれば
        if (mouseButton == LEFT) {           // 左ボタンが押されているか
            port.write('s');                 // ストップの指令を送信する
            text("ストップ", 10, 35);        // 左上にその値を表示する
            rect(mouseX, mouseY, 10, 10);    // マウスの位置に円を描く
        } else if (mouseButton == RIGHT) {   // 右ボタンが押されているか
            port.write('b');                 // ブレーキの指令を送信する
            text("ブレーキ", 10, 35);        // 左上にその値を表示する。
            line(mouseX-5, mouseY-5, mouseX+5, mouseY+5);  // マウスの位置に×印を描く
            line(mouseX-5, mouseY+5, mouseX+5, mouseY-5);
        }
    }
}

