import processing.serial.*;  // Arduinoと通信するためのライブラリを読み込む

Serial port;                 // シリアル通信を行うための変数の定義

void setup()
{
    size(255, 255);                         // 255×255ドットの画面を作成
    port = new Serial(this, "COM3", 9600);  // 通信ポートと速度の設定
    stroke(0);                              // 線の色を黒
    strokeWeight(5);                        // 線の太さを5pt
    fill(0);                                // 塗りつぶし色を黒
    textSize(36);                           // 文字の大きさを36pt
    frameRate(30);                          // フレームレートを30fps
}

void draw()
{
    int mx, my;
    float th;
    th = atan2((mouseY-128), (mouseX-128)); // マウスの座標から角度を計算
    mx = int(80*cos(th))+128;               // その角度から線の先端の位置を計算
    my = int(80*sin(th))+128;

    background(255);                        // 画面を白で塗りつぶして更新
    line(128, 128, mx, my);                 // マウス位置の方向へ線を引く
    ellipse(mouseX, mouseY, 10, 10);        // マウス位置に円を描く
    int v = int(th/3.14*180)-30;            // ラジアン角からデグリー角へ変換
    text(v, 50, 50);                        // 角度を右上に表示
    port.write(v);                          // 角度を送信
}

