import processing.serial.*;    // Arduinoと通信するためのライブラリを読み込む

Serial port;                   // シリアル通信を行うための変数の定義

void setup()
{
    size(255, 80);                              // 255×80ドットの画面を作成
    port = new Serial(this, "COM3", 9600);      // 通信ポートと速度の設定
    background(255);                            // 背景を白
    stroke(0);                                  // 線の色を黒
    fill(0);                                    // 文字の色を黒
    port.clear();                               // 受信データをクリア
}

void draw()
{
    int c;
    if (port.available() > 4) {                 // データが5以上送られて来たら
        c = port.read();                        // データを読み込む
        if (c == 'a') {                         // 先頭データの合図である「a」であれば
            background(255);                    // 画面を白で塗りつぶして更新
            c = port.read();                    // データを読み込む
            text("スイッチ1：" + c, 10, 15);    // スイッチ1の値を表示
            line(0, 20, 255, 20);               // 区切り線
            c = port.read();
            text("スイッチ2：" + c, 10, 35);    // スイッチ2の値を表示
            line(0, 40, 255, 40);               // 区切り線
            c = port.read();
            text("ボリューム1：" + c, 10, 55);  // ボリューム1の値を表示
            line(0, 60, 255, 60);               // 区切り線
            c = port.read();
            text("ボリューム2：" + c, 10, 75);  // ボリューム2の値を表示
        }
    }
}

