import processing.serial.*;  // Arduinoと通信するためのライブラリを読み込む

Serial port;                 // シリアル通信を行うための変数の定義

void setup()
{
    size(255, 255);                         // 255×255ドットの画面を作成
    port = new Serial(this, "COM3", 9600);  // 通信ポートと速度の設定
    stroke(0);                              // 線の色を黒
    fill(255);                              // 塗りつぶし色を白
    rectMode(CENTER);                       // 四角形を描くときの基準点を中心
    port.clear();                           // 受信データをクリア
}

void draw()
{
    // 何もしない
}

void serialEvent(Serial p) {
    background(192);                    // 画面を明るい灰色で塗りつぶして更新
    int c = port.read();                // データを読み込む
    if (c == 'a')                       // 「a」ならば
        ellipse(127, 127, 100, 100);    // 円を表示
    else if (c == 'b')                  // 「b」ならば
        rect(127, 127, 100, 100);       // 四角を表示
}

