import processing.serial.*;    // Arduinoと通信するためのライブラリを読み込む

Serial port;                   // シリアル通信を行うための変数の定義

void setup()
{
    size(255, 255);                         // 255×255ドットの画面を作成
    port = new Serial(this, "COM3", 9600);  // 通信ポートと速度の設定
    background(192);                        // 背景を明るい灰色
    stroke(0);                              // 線の色を黒
    strokeWeight(5);                        // 線の太さを5pt
    fill(0);                                // 文字の色を黒
    textSize(24);                           // 文字の大きさを24pt
    port.write('a');                        // Arduinoに返信要求を送る
}

void draw()
{
    int x, y, z;
    if (port.available() > 2) {         // データが3以上送られて来たら
          x = port.read();              // x，y，z方向のデータを読み込む
          y = 255-port.read();
          z = port.read();
          background(192);              // 画面を明るい灰色で塗りつぶして更新
          line(128, 128, x, y);         // 画面の中心からx，y方向へ線を引く
          text("X:" + x, 10, 30);       // 画面の左上に受信した値を表示
          text("Y:" + y, 10, 60);
          text("Z:" + z, 10, 90);
          port.write('a');              // Arduinoに返信要求を送る
    }
}

void mousePressed()
{
    port.write('a');                    // 返信要求を送る
}

