import processing.serial.*;    // Arduinoと通信するためのライブラリを読み込む

Serial port;                   // シリアル通信を行うための変数の定義
int x, y, z;                   // 3軸加速度の値を保存するための変数の定義

void setup()
{
    size(255, 255);                         // 255×255ドットの画面を作成
    port = new Serial(this, "COM3", 9600);  // 通信ポートと速度の設定
    background(192);                        // 背景を明るい灰色
    stroke(0);                              // 線の色を黒
    strokeWeight(5);                        // 線の太さを5pt
    fill(0);                                // 文字の色を黒
    textSize(24);                           // 文字のサイズを24pt
    port.bufferUntil('\n');                 // serialEvent関数の呼び出し条件の設定
    port.write('a');                        // Arduinoに返信要求を送る
    x = y = z = -1;
}

void draw()
{
    background(192);           // 画面を明るい灰色で塗りつぶして更新
    line(128, 128, x/4, y/4);  // 画面の中心からx,y方向へ線を引く
    text("X:" + x, 10, 30);    // 画面の左上上に受信した値を表示
    text("Y:" + y, 10, 60);
    text("Z:" + z, 10, 90);
}

void serialEvent(Serial p)
{
    String ms = port.readStringUntil('\n');  // 文字列の読み込み
    ms = trim(ms);                           // 改行コードの削除
    int data[] = int(split(ms, ','));        // カンマ区切りの文字列を4つの数字に変換
    x = data[0];                             // それぞれの値をそれぞれの状態を表す変数に代入
    y = data[1];
    z = data[2];
    port.write('a');                         // Arduinoに再度送信するように通信の開始合図を送信
}

void mousePressed()
{
    port.write('a');                         // 返信要求を送る
}

