import processing.serial.*;    // Arduinoと通信するためのライブラリを読み込む

Serial port;                   // シリアル通信を行うための変数の定義

void setup()
{
    size(255, 255);                         // 255×255ドットの画面を作成
    port = new Serial(this, "COM3", 9600);  // 通信ポートと速度の設定
    stroke(0);                              // 線の色を黒
    fill(255);                              // 塗りつぶし色を白
    textSize(48);                           // 文字の大きさを48pt
    port.clear();                           // 受信データをクリア
}
void draw()
{
    if(port.available() > 0){
        background(192);              // 画面を明るい灰色で塗りつぶして更新
        int v = port.read();          // データを読み込む
        fill(v);                      // 送られてきたデータで塗りつぶし色を変える
        ellipse(127, 127, 100, 100);  // 円を表示
        fill(0);                      // 文字の色を黒
        text(v, 10, 50);              // 左上に送られてきた値を表示
    }
}

