import processing.serial.*;    // Arduinoと通信するためのライブラリを読み込む

Serial port;                   // シリアル通信を行うための変数の定義
int angle;                     // サーボモーターの角度を保存する変数の定義

void setup()
{
    size(255, 255);                         // 255×255ドットの画面を作成
    port = new Serial(this, "COM3", 9600);  // 通信ポートと速度の設定
    background(255);                        // 背景を白
    angle = 60;                             // 初期角度を60度
    port.write(angle);                      // Arduinoにサーボモーターの角度を送る
}

void draw()
{
    int c;
    if (port.available() > 0) {             // データが送られてきたか？
        float a;
        c = port.read();                    // 距離センサの値を読み込む
        if (c > 0)                          // センサの値が1より大きいか？
            a = (float)(4000.0/c);          // 距離に直す
        else
            a = 4000;                       // 0ならば距離を4000にする
        stroke(255);                        // 線の色を白に
        line(128, 0, 4000*cos((angle+30)/180.0*PI)+128, 4000*sin((angle+30)/180.0*PI));  // 白い線で前回の線を消す
        stroke(0);                          // 線の色を黒に
        line(128, 0, a*cos((angle+30)/180.0*PI)+128, a*sin((angle+30)/180.0*PI));  // 距離を線の長さで表す
        angle++;                            // 角度を1度増やす
        if (angle > 120)angle = 0;          // 120度を超えたら0度に戻す
            port.write(120-angle);          // Arduinoにサーボモーターの角度を送る
    }
}

void mousePressed()
{
    angle = 60;                             // 初期角度を60度
    port.write(angle);                      // Arduinoにサーボモーターの角度を送る
}

