import processing.serial.*;    // Arduinoと通信するためのライブラリを読み込む

Serial port;                   // シリアル通信を行うための変数の定義

void setup()
{
    size(255, 255);                         // 255×255ドットの画面を作成
    port = new Serial(this, "COM4", 9600);  // 通信ポートと速度の設定
    frameRate(30);                          // フレームレート
    strokeWeight(5);                        // 線の太さを5pt
    stroke(0);                              // 線の色を黒
    textAlign(CENTER);                      // 文字の基準位置を中心
    textSize(48);                           // 文字の大きさを48pt
    rectMode(CENTER);                       // 四角形の基準位置を中心
}

void draw()
{
    background(255);                           // 画面の更新
    noFill();                                  // 塗りつぶしをしない
    if (mousePressed == true) {                // マウスが押されていれば
        port.write('a');                       // 「a」を送信
        ellipse(width/2, height/2, 150, 150);  // 円を表示
    } else {                                   // 離されていれば
        port.write('b');                       // 「b」を送信
        rect(width/2, height/2, 150, 150);     // 四角を表示
    }
    fill(0);                                   // 文字の色を黒
    if (port.available() > 0) {                // 受信データがあるか
        int v = port.read();
        text(v, width/2, height/2);            // 受信データを文字で表示
        println(v);
    }
}
