#include <CapacitiveSensor.h>

#include <CapacitiveSensor.h>				// 静電容量センサのライブラリの読み込む

CapacitiveSensor cs_3_4 = CapacitiveSensor(3,4);	// 3，4番ピンを使った静電容量センサとする
CapacitiveSensor cs_5_6 = CapacitiveSensor(5,6);	// 5，6番ピンを使った静電容量センサとする
int fs,fk;					// センサに触れた瞬間かどうかを判別するための変数

void setup()
{
    Serial.begin(9600);			// 通信ポートと速度の設定
    cs_3_4.set_CS_AutocaL_Millis(0xFFFFFFFF);	// 静電容量センサのキャリブレーション設定
    cs_5_6.set_CS_AutocaL_Millis(0xFFFFFFFF);
    fs = fk = 0;				// 触れられていないとして初期化
}

void loop()
{
    long cs34 = cs_3_4.capacitiveSensor(30);	// 静電容量センサの値
    if(cs34 > 500){				// 触れられていれば
        if(fs == 0){				// その前の瞬間が触れられていなければ
            fs = 1;
            Serial.write('s');			// 「s」を送信
        }
    }
    else if(cs34 < 200){			// 触れられていなければ
        fs = 0;
    }
    long cs56 = cs_5_6.capacitiveSensor(30);	// 静電容量センサの値
    if(cs56 > 500){				// 触れられていれば
        if(fk == 0){				// その前の瞬間が触れられていなければ
            fk = 1;
            Serial.write('k');			// 「k」を送信
        }
    }
    else if(cs56 < 200){			// 触れられていなければ
        fk = 0;
    }
}

