import processing.serial.*;    // Arduinoと通信するためのライブラリを読み込む
import ddf.minim.*;            // 音を再生するためのライブラリを読み込む

Serial port;                   // シリアル通信を行うための変数の定義
Minim minim;                   // 音を出すための変数を定義
AudioSample snare;             // 「シャン」という音のための変数
AudioSample kick;              // 「ボン」という音のための変数
int ts, tk;                    // 視覚エフェクトのための変数

void setup()
{
    size(200, 200);                           // 200×200ドットの画面を作成
    port = new Serial(this, "COM3", 9600);    // 通信ポートと速度の設定
    fill(0);                                  // 塗りつぶし色を黒
    minim = new Minim(this);                  // 音を再生するための変数
    kick = minim.loadSample("BD.mp3", 512);   // 「ボン」という音の読み込み
    snare = minim.loadSample("SD.wav", 512);  // 「シャン」という音の読み込み
}

void draw()
{
    background(255);           // 背景を白で塗りつぶして更新
    if(port.available() > 0){  // データが送られて来たか？
        int c = port.read();
        if(c == 's'){          // 「s」だったら
            snare.trigger();   // 「シャン」と鳴らす
            ts = 200;          // 黒の帯を最大高さに
        }
        if(c == 'k'){          // 「k」だったら
            kick.trigger();    // 「ボン」と鳴らす
            tk = 200;          // 黒の帯を最大高さに
        }
    }
    rect(20, 200, 60, -ts);    // 黒い帯を描く
    rect(120, 200, 60, -tk);
    if(ts > 0)ts -= 10;        // 黒い帯が0より大きければ短くする
    if(tk > 0)tk -= 10;
}
// おまけの機能
void keyPressed()
{
    if (key == 's'){           // 「s」キーが押されたら
        snare.trigger();       // 「シャン」と鳴らす
        ts = 200;              // 黒の帯を最大高さに
    }
    if (key == 'k'){           // 「k」キーが押されたら
        kick.trigger();        // 「ボン」と鳴らす
        tk = 200;              // 黒の帯を最大高さに
    }
}

