import processing.serial.*;    // Arduinoと通信するためのライブラリを読み込む
import org.gamecontrolplus.*;  // ゲームパッドを使うためのライブラリを読み込む
import java.util.List;

Serial port;                   // シリアル通信を行うための変数の定義
ControlIO control;             // ゲームパッドを使うための変数の定義
List<ControlDevice> list;
ControlDevice device;
ControlButton[] button = new ControlButton[8];
ControlSlider[] sliders = new ControlSlider[2];

void setup() {
    port = new Serial(this, "COM3", 9600);  // 通信ポートと速度の設定
    control = ControlIO.getInstance(this);  // ゲームパッドを使うための設定
    list = control.getDevices();            // 使用できるゲームパッドの取得
    println(list);                          // 使用できるゲームパッドリストの表示
    device = list.get(2);                   // ゲームパッドの設定（この2という番号はゲームパッドリストを見てから決める）
    device.open();
    int i;
    for (i=0; i<8; i++) {
        button[i] = device.getButton(i);    // 8個のボタンが押されているかどうかを取得
    }
    sliders[0] = device.getSlider(2);       // アナログスティックの横方向の状態を取得
    sliders[1] = device.getSlider(3);       // アナログスティックの縦方向の状態を取得
}

void draw() {
    int vl, vr;

    vl = (int)((-sliders[0].getValue()+sliders[1].getValue())*127);  // 十字キーもしくはアナログスティックからの入力を速度に変換
    vr = (int)((-sliders[0].getValue()-sliders[1].getValue())*127);
    println(vl + "," + vr);

    if(vl > 0) {           // vlが正だったら
        port.write('l');   // 左車輪正転のlを送って
        port.write(vl);    // 速度を送る
    }else {                // vlが負だったら
        port.write('L');   // 左車輪逆転のLを送って
        port.write(-vl);   // 速度を送る
    }
    if(vr > 0) {           // vrが正だったら
        port.write('r');   // 右車輪正転のrを送って
        port.write(vr);    // 速度を送る
    }else {                // vrが負だったら
        port.write('R');   // 右車輪逆転のRを送って
        port.write(-vr);   // 速度を送る
    }
}

